/************************************************** 
*
*  Copyright (c) 2006-2007 VIXS Systems Inc. All rights reserved
*
*  FILENAME: xc3fb_if.h  
*
*  DESCRIPTION:   
*               
*
*  AUTHOR:
*
*  HISTORY
*
*  $Log: not supported by cvs2svn $
*  Revision 1.2  2009/12/14 19:20:52  lichen
*  adding virtual layer
*
*  Revision 1.1  2009/11/26 20:31:03  lichen
*  move xc3fb_if.h to xc4fb_if.h
*
*  Revision 1.2  2009/08/04 14:10:37  lichen
*  gra0 and vid0 work for 480i, 480p, 720p, 1080i
*
*  Revision 1.1  2009/04/03 22:11:43  lichen
*  port Directfb 1.3 to arc, add xcode4 driver
*
*  Revision 1.1  2008/10/10 14:39:39  lichen
*  for adding gfxdriver vixs_xcode4
*
*  Revision 1.15  2008/10/06 16:00:59  jdoyle
*  Added new APP ioctl to get ther FB aperture details
*
*  Revision 1.14  2008/09/18 21:50:17  jdoyle
*  Moved memory range up by 4MB
*  Increased minor version number
*
*  Revision 1.13  2008/09/16 16:20:38  jdoyle
*  Increased version
*
*  Revision 1.12  2008/09/16 05:16:19  jdoyle
*  Added new IOCTL interface
*
*  Revision 1.11  2008/08/13 17:20:53  jdoyle
*  Version number increase
*
*  Revision 1.10  2008/08/08 00:06:20  jdoyle
*  New version
*
*  Revision 1.9  2008/07/30 17:45:30  jdoyle
*  Increased sub-minor version number
*
*  Revision 1.8  2008/07/25 22:41:00  jdoyle
*  Increased version sub-minor number
*
*  Revision 1.7  2008/07/25 17:45:11  jdoyle
*  Increased version number
*
*  Revision 1.6  2008/07/09 16:31:25  jdoyle
*  Increased sub-version number
*
*  Revision 1.5  2008/06/29 01:17:47  jdoyle
*  Changed rev number
*  Reduced memory footprint
*
***************************************************/
#ifndef H_XC3FB_IF_H

#define H_XC3FB_IF_H

#define FB_ACCEL_VIXS_XC4 143

#define XC_FB_DEV_NAME   "vixsfb"
#define XC_FB_DRIVER_NAME     "ViXS XC-IV FB"
#define XC_FB_DRIVER_VERSION_NAME     "0.16.1"



#define ONE_MEG 0x100000

#define ONE_K 0x400

#define XC3_SOC_MEM_PHYS 0x80000000 


//#define FPGA_BUILD

#ifdef FPGA_BUILD

#define XC3_SOC_FB_MEM_OFFSET   (22 * ONE_MEG)

#else

#define XC3_SOC_FB_MEM_OFFSET   (154 * ONE_MEG)

#endif

#define XC3_SOC_FB_PHYS  XC3_SOC_MEM_PHYS + XC3_SOC_FB_MEM_OFFSET

#ifdef FPGA_BUILD

#define XC3_SOC_FB_SIZE (ONE_MEG * 10 ) 

#else

#define XC3_SOC_FB_SIZE (ONE_MEG * 38 ) 

#endif

#define XC3_SOC_MMR_PHYS 0xD0000000
#define XC3_SOC_MMR_SIZE 0x10000

#define UPSCALE_DMA_AREA XC3_SOC_FB_MEM_OFFSET+XC3_SOC_FB_SIZE;

//
// Valid address range for FB applications
// 
#define APPLICATION_FB_OFFSET 0 //(ONE_MEG * 40 ) //(ONE_K * 512)


//
//PHYS address delta (when mapping a DFB offset to actual XC3 memory)
// 
#define   XC_DFB_PHYS_TRANSLATION  (APPLICATION_FB_OFFSET +XC3_SOC_FB_MEM_OFFSET) 

//
//Temp. offset for now
// 

#define DMA_DESC_APER_SIZE    (ONE_K * 64)


#define XC3_FB_DRIVER   "/dev/xc3fb"

#define DEFAULT_FB_DRIVER   "/dev/fb0"




#define   HEIGHT_1152    1152

#define   WIDTH_1024     1024
#define   PITCH_1024     1024
#define   YUV_1024x1088_PLANE_SIZE  (PITCH_1024 * YUV_1088_HEIGHT)  


#define RGB_720_WIDTH     720

#define RGB_576_HEIGHT    576
#define RGB_720_HEIGHT     720

#define RGB_480_HEIGHT     480
#define RGB_720_PITCH      (RGB_720_WIDTH*4)


#define RGB_720_480_PITCH  (RGB_720_PITCH)    //aRGB
#define RGB_720_480_PLANE_SIZE (RGB_720_480_PITCH*RGB_480_HEIGHT)   
#define RGB_720_576_PLANE_SIZE (RGB_720_480_PITCH*RGB_576_HEIGHT)   



#define RGB_720480i_WIDTH      720
#define RGB_720480i_HEIGHT     480
#define RGB_720480i_PITCH      (720*4)    //aRGB
#define RGB_720480i_PLANE_SIZE (RGB_720480i_PITCH*RGB_720480i_HEIGHT)   

#define YUV_720480i_WIDTH       720

#define YUV_768576i_WIDTH       768
#define YUV_768576i_HEIGHT      576
#define YUV_768576i_Y_PITCH     768
#define YUV_768576i_PLANE_SIZE  (YUV_768576i_WIDTH * YUV_768576i_HEIGHT)  //interlace


#define YUV_768480i_PLANE_SIZE  (YUV_768576i_WIDTH * YUV_720480i_HEIGHT) /2  //interlace
#define YUV_768512i_PLANE_SIZE  (YUV_768576i_WIDTH * YUV_768512i_HEIGHT) /2  //interlace


#define   YUV_720_WIDTH  720
#define   YUV_732_WIDTH  732
#define   YUV_732_PITCH  YUV_732_WIDTH

#define   YUV_736_WIDTH  736
#define   YUV_736_PITCH  YUV_736_WIDTH
#define   YUV_736x1088_PLANE_SIZE  (YUV_736_PITCH  * YUV_1088_HEIGHT)  
#define   YUV_736x1088i_PLANE_SIZE  (YUV_736x1088_PLANE_SIZE /2)  



#define   YUV_768_WIDTH  768
#define   YUV_768_PITCH  YUV_768_WIDTH
#define   YUV_768_HEIGHT 768
#define   YUV_768x768_PLANE_SIZE  (YUV_768_PITCH  * YUV_768_HEIGHT)  
#define   YUV_768x768i_PLANE_SIZE  (YUV_768x768_PLANE_SIZE) /2 

//
//1280x720 variables
// 
#define   YUV_1280_WIDTH      1280
#define   YUV_1280_PITCH      YUV_1280_WIDTH
#define   YUV_1280x768_PLANE_SIZE (YUV_1280_PITCH  * YUV_768_HEIGHT )
#define   YUV_1280x768i_PLANE_SIZE (YUV_1280x768_PLANE_SIZE) /2
#define   RGB_1280_PITCH  (YUV_1280_WIDTH*4)
#define   RGB_1280x768_PLANE_SIZE (RGB_1280_PITCH * RGB_720_HEIGHT)


#define   YUV_720_HEIGHT      720

#define   YUV_732x1088_PLANE_SIZE  (YUV_732_PITCH * YUV_1088_HEIGHT)
#define   YUV_732x1088i_PLANE_SIZE (YUV_732x1088_PLANE_SIZE /2)




#define   YUV_720_WIDTH  720
#define   YUV_720_Y_PITCH  720

#define   YUV_1080_HEIGHT 1080
#define   YUV_1088_HEIGHT 1088
#define   YUV_720x1088_PLANE_SIZE  (YUV_720_Y_PITCH  * YUV_1088_HEIGHT)  
#define   YUV_720x1088i_PLANE_SIZE  (YUV_720x1088_PLANE_SIZE) /2 

#define   YUV_1920_WIDTH      1920








#define   YUV_512_HEIGHT 512


#define YUV_768512i_HEIGHT      512

#define YUV_768480i_WIDTH       768

#define YUV_720480i_HEIGHT      480
#define YUV_576i_HEIGHT      576
#define YUV_576_HEIGHT      576
#define YUV_512_HEIGHT      512

#define YUV_720480i_Y_PITCH     768 //YUV_720480i_WIDTH
#define YUV_720480i_PLANE_SIZE  (YUV_720480i_Y_PITCH * YUV_576i_HEIGHT ) /2 //interlace
#define U_720480i_PLANE_OFFSET   (YUV_720480i_PLANE_SIZE*2) //interlace
#define V_720480i_PLANE_OFFSET   U_720480i_PLANE_OFFSET+(768*120)

//#define V_720480i_PLANE_OFFSET   (U_720480i_PLANE_OFFSET+(YUV_720480i_PLANE_SIZE / 2  ) ) //interlace

#define YUV_720576i_WIDTH       720
#define YUV_720576i_HEIGHT      480
#define YUV_720576i_Y_PITCH     720                 
#define YUV_720576i_PLANE_SIZE  (YUV_720576i_Y_PITCH * YUV_720576i_HEIGHT ) /2 //interlace




#define RGB_1920_WIDTH      1920

#define RGB_19201080i_WIDTH      1920
#define RGB_19201080i_HEIGHT     1080
#define RGB_19201080i_PITCH      (RGB_19201080i_WIDTH*4)    //aRGB
#define RGB_19201080i_PLANE_SIZE (RGB_19201080i_PITCH*RGB_19201080i_HEIGHT)    

#define YUV_19201080i_WIDTH     1920
#define YUV_19201080i_HEIGHT    1080
#define YUV_19201080i_Y_PITCH   1920
#define YUV_19201080i_PLANE_SIZE   (YUV_19201080i_Y_PITCH*YUV_19201080i_HEIGHT) /2 //interlace




#define YUV_20481088i_WIDTH     2048
#define YUV_20481088i_HEIGHT    1088
#define YUV_20481088i_Y_PITCH   2048

#define YUV_20481088_FRAME_SIZE    YUV_20481088i_Y_PITCH * YUV_20481088i_HEIGHT * 1.5
#define YUV_720480_FRAME_SIZE      YUV_720480i_WIDTH * YUV_720480i_HEIGHT  * 1.5


#define YUV_19201088i_PLANE_SIZE   (YUV_20481088i_Y_PITCH*YUV_20481088i_HEIGHT) /2 //interlace
#define YUV_20481088i_PLANE_SIZE   (YUV_20481088i_Y_PITCH*YUV_20481088i_HEIGHT) /2 //interlace

#define U_19201088i_PLANE_OFFSET   (YUV_19201088i_PLANE_SIZE*2) //interlace
#define V_19201088i_PLANE_OFFSET   (U_19201088i_PLANE_OFFSET+(YUV_19201088i_PLANE_SIZE / 4) ) //interlace

#define UV_20481088i_PLANAR_8x8_HEIGHT    576
#define UV_20481088i_PLANAR_8x8_SIZE    UV_20481088i_PLANAR_8x8_HEIGHT * YUV_20481088i_Y_PITCH




//
//Output modes for DVE:
//R denotes RGB, Y is YUV, i is interlaces and p is progressive
//
 
enum
{
    DVE_OM_R_480i,
    DVE_OM_R_1080i,
    DVE_OM_Y_420_480i,
    DVE_OM_Y_420_1088i,
    DVE_OM_AR_1080i,               //4
    DVE_OM_Y_420_720_to_1920,             //This mode is horizontally upscaled to 1920
    DVE_OM_Y_420_720p,             //
    DVE_OM_R_720p,                 //
    DVE_OM_Y_420_480p,             //
    DVE_OM_R_480p,                 //
    DVE_OM_R_576i,                 //
    DVE_OM_Y_576i,                 //
    DVE_OM_R_1080i_PAL,
    DVE_OM_Y_420_1088i_PAL,
    DVE_OM_Y_422_480i,             //NOt implemented yet
    DVE_OM_REALMODES_EOL,
    DVE_OM_ALPHA_R_480i=64,        //Configure both DVE's
    DVE_OM_ALPHA_R_1080i,          //COnfigure both DVE's
    DVE_OM_ALPHA_R_720_TO_1920,    //Upscaled 720->1920 video with 1920x1080 RGB PLANE
    DVE_OM_ALPHA_R_720p,           //1280x720p Alpha mode
    DVE_OM_ALPHA_R_480p,           //720x480p Alpha mode
    DVE_OM_ALPHA_R_576i,           //720x576i Alpha mode(PAL)
    DVE_OM_ALPHA_R_1080i_PAL,
    DVE_OM_EOL

}; //DVE_OUTPUT_MODES;



#define DVE_UPDATE_DVE0    0x00000001  //Instruct driver to DVE0 addresses
#define DVE_UPDATE_DVE1    0x00000002  //Instruct driver to DVE1 addresses





#define OUTPUT_MODE_STRING_SIZE 64


//#define DVE_OUTPUT_MODE_TILED8 (1 << 0)

//#define DVE_OUTPUT_MODE_TILED16 (1 << 1)


#define   DVE_OUTPUT_MODE_IS_RGB     (1 << 0)
#define   DVE_OUTPUT_MODE_IS_YUV     (1 << 1)
#define   DVE_OUTPUT_MODE_TILED8     (1 << 2)   
#define   DVE_OUTPUT_MODE_TILED16    (1 << 3)
#define   DVE_OUTPUT_MODE_SD_TIMING  (1 << 4)

#endif  //XC3FB_IF_H
