/*
   ViXS Xcode4 driver - 2D Acceleration

   (c) Copyright 2007  Telio AG

   Written by LiYi Chen


*/

#ifndef __VIXS_2D_H__
#define __VIXS_2D_H__


#define XC4_SUPPORTED_DRAWINGFLAGS \
               (DSDRAW_NOFX | \
               DSDRAW_BLEND | \
               DSDRAW_DST_COLORKEY | \
               DSDRAW_SRC_PREMULTIPLY | \
               DSDRAW_XOR)

#define XC4_SUPPORTED_BLITTINGFLAGS \
               (DSBLIT_NOFX | \
                DSBLIT_BLEND_ALPHACHANNEL | \
                DSBLIT_COLORIZE | \
                DSBLIT_BLEND_COLORALPHA | \
                DSBLIT_ROTATE180 | \
                DSBLIT_FLIP_VERTICAL | \
                DSBLIT_FLIP_HORIZONTAL | \
                DSBLIT_SRC_COLORKEY | \
                DSBLIT_DST_COLORKEY | \
                DSBLIT_XOR | \
                DSBLIT_SRC_PREMULTIPLY  | \
                DSBLIT_SRC_PREMULTCOLOR | \
                DSBLIT_DST_PREMULTIPLY | \
				DSBLIT_LINEAR_STRETCH)

#define XC4_FES_SUPPORTED_BLITTINGFLAGS \
               (DSBLIT_NOFX | \
                DSBLIT_BLEND_ALPHACHANNEL | \
                DSBLIT_BLEND_COLORALPHA)

#define XC4_GIC_SUPPORTED_BLITTINGFLAGS \
               (DSBLIT_NOFX | \
                DSBLIT_BLEND_ALPHACHANNEL | \
                DSBLIT_BLEND_COLORALPHA | \
                DSBLIT_SRC_PREMULTIPLY  | \
                DSBLIT_SRC_PREMULTCOLOR  )


#define XC4_SUPPORTED_DRAWINGFUNCTIONS \
               (DFXL_FILLRECTANGLE)


#define XC4_SUPPORTED_BLITTINGFUNCTIONS \
               (DFXL_BLIT | \
                DFXL_STRETCHBLIT)


#define SIZE_OF_SRC_COLOR_KEY 3
#define SIZE_OF_DST_COLOR_KEY 3
#define SIZE_OF_SET_CLIP_REGION 2
#define SIZE_OF_SET_PATTERN 2
#define SIZE_OF_SET_DESTINATION_REGISTERS 3
#define SIZE_OF_SET_SOURCE_REGISTERS 4
#define SIZE_OF_G2D_OPERATION_FINISH 3
#define SIZE_OF_G2D_OPERATION_FINISH_FOR_STRETCH_BLIT 4

#define BASE_SIZE_OF_BLIT \
    SIZE_OF_SET_DESTINATION_REGISTERS + SIZE_OF_SET_SOURCE_REGISTERS + SIZE_OF_G2D_OPERATION_FINISH

#define BASE_SIZE_OF_STRETCH_BLIT \
    SIZE_OF_SET_DESTINATION_REGISTERS + SIZE_OF_SET_SOURCE_REGISTERS + SIZE_OF_G2D_OPERATION_FINISH_FOR_STRETCH_BLIT

#define BASE_SIZE_OF_FILLRECTANGLE \
    SIZE_OF_SET_DESTINATION_REGISTERS + SIZE_OF_G2D_OPERATION_FINISH

#define SCALER_MULTIPLY_SHIFT 12

#define XC_G2D_OP_COPY_RECT  0
#define XC_G2D_OP_DRAW_RECT	 1
#define XC_G2D_OP_FILL_RECT  2
#define XC_G2D_OP_DRAW_LINE  3
#define XC_G2D_OP_DRAW_AA_LINE 4
#define XC_G2D_OP_NO_SRC_PLANE 5

#define XC_G2D_OP_SCALE_RECT 6

#define SRC_ALPHA_WRITE_OUT 1


#define PIX_FORMAT_MONOCHROME 0
#define PIX_FORMAT_LUT4 1
#define PIX_FORMAT_LUT8 2
#define PIX_FORMAT_RGB1555 3
#define PIX_FORMAT_RGB565 4
#define PIX_FORMAT_RGB32 5
#define PIX_FORMAT_LUT2 6
#define PIX_FORMAT_RGB4444 7
#define PIX_FORMAT_UNKNOWN 255

#define GFX_ALPHA_MODE_NO_ALPHA             0
#define GFX_ALPHA_MODE_SRC_ALPHA            1
#define GFX_ALPHA_MODE_FGND_COLOR_ALPHA     2
#define GFX_ALPHA_MODE_GRADIENTS_ALPHA      3
#define GFX_ALPHA_MODE_INVERT_SOURCE_ALPHA  4
#define GFX_ALPHA_MODE_INVERT_DEST_ALPHA    5
#define GFX_ALPHA_MODE_DEST_ALPHA           6


#define COMPARE_FNCT_EQUAL 2
#define COMPARE_FNCT_NOT_EQUAL 3

#define COMPARE_MASK_NO_ALPHA 0x00FFFFFF
#define COMPARE_MASK_ALPHA_ONLY 0xFF000000

#define COMPARE_INPUT_SRC_DATA 0
#define COMPARE_INPUT_DST_DATA 1

#define SRC_RLE_DATA 1

#define COLOR_KEY_OFF 0
#define COLOR_KEY_ON 1

#define SRC_LINEAR_DATA 1

#define SCALING_TYPE_NEIGHBOR 1
#define SCALING_TYPE_LERP     0
#define SRC_SCALE_ALPHA_PREMULT 1

#define SCALE_START_0         1
#define SCALE_START_NEG0p5_PLUS_0p5SCALE  0


#define GFX_ROP_BLACK       0
#define GFX_ROP_COPYPEN     1
#define GFX_ROP_MASKNOTPEN  2 
#define GFX_ROP_MASKPEN     3
#define GFX_ROP_MASKPENNOT  4
#define GFX_ROP_MERGENOTPEN 5
#define GFX_ROP_MERGEPEN    6
#define GFX_ROP_MERGEPENNOT 7
#define GFX_ROP_NOP         8
#define GFX_ROP_NOT         9
#define GFX_ROP_NOTCOPYPEN  10
#define GFX_ROP_NOTMASKPEN  11
#define GFX_ROP_NOTMERGEPEN 12
#define GFX_ROP_NOTXORPEN   13
#define GFX_ROP_WHITE       14
#define GFX_ROP_XORPEN      15
#define GFX_ROP_MERGECOPY   16

#define GFX_ROP_MODE_MIXED_ENABLE 1
#define GFX_SCISSOR_DISABLE       1

#define GFX_ROP_ALPHA_FORMAT_SRC_ALPHA      0
#define GFX_ROP_ALPHA_FORMAT_DST_ALPHA      1
#define GFX_ROP_ALPHA_FORMAT_FG_COLOR       2
#define GFX_ROP_ALPHA_FORMAT_MIX_ALPHA      3


#define XC_G2D_OP_SRC_SEL_BLT       0
#define XC_G2D_OP_SRC_SEL_FRGND_CLR 1
#define XC_G2D_OP_SRC_SEL_SRC_PATTERN 3
#define XC_G2D_OP_SRC_SEL_MEM_PATTERN 5
#define XC_G2D_OP_SRC_SEL_SRC_PEN 7

//define blit direction
#define LEFT_TO_RIGHT_TOP_TO_BOT    1
#define RIGHT_TO_LEFT_TOP_TO_BOT    2
#define LEFT_TO_RIGHT_BOT_TO_TOP    3
#define RIGHT_TO_LEFT_BOT_TO_TOP    4

/* GIC_CONFIG_CTRL flags */

#define	GIC_DISABLE_CLUT_PROG	0
#define	GIC_PROGRAM_ALL_CLUT	1
#define GIC_PROGRAM_SRC1_CLUT	2
#define GIC_PROGRAM_SRC2_CLUT	3

/* */

#define	GIC_MIN_X_SIZE			4
#define	GIC_MIN_Y_SIZE			4


/*  Surface constants for the getSurfaceInfo function used for 
*   "graphics" uOps..
*/
#define SURFACE_SOURCE          -1
#define SURFACE_DEST            -2


DFBResult xcodeEngineSync         ( void                *drv,
                                    void                *dev );
                                  
void      xcodeEngineReset        ( void                *drv,
                                    void                *dev );
                                  
void      xcodeCheckState         ( void                *drv,
                                    void                *dev,
                                    CardState           *state,
                                    DFBAccelerationMask  accel );
                                  
void      xcodeSetState           ( void                *drv,
                                    void                *dev,
                                    GraphicsDeviceFuncs *funcs,
                                    CardState           *state,
                                    DFBAccelerationMask  accel );

bool      xcodeBlit                    ( void                 *drv, 
                                    void                 *dev, 
                                    DFBRectangle         *rect, 
                                    int                  dx, 
                                    int                  dy )
;

bool      xcodeFillRectangle      ( void                *drv, 
                                    void                *dev, 
                                    DFBRectangle        *rect );

bool      xcodeStretchBlit        ( void                *drv, 
                                    void                *dev, 
                                    DFBRectangle        *src_rec, 
                                    DFBRectangle        *dst_rec);

void      xcodeA8SetColor         ( void *drv, 
                                    void *dev, 
                                    u32  *palette);
                                    
                                    
                                    
                                    
DFBResult xcodeDummyEngineSync         ( void                *drv,
                                        void                *dev );
                                  
void      xcodeDummyEngineReset        ( void                *drv,
                                        void                *dev );
                                  
void      xcodeDummyCheckState         ( void                *drv,
                                        void                *dev,
                                        CardState           *state,
                                        DFBAccelerationMask  accel );
                                  
void      xcodeDummySetState           ( void                *drv,
                                        void                *dev,
                                        GraphicsDeviceFuncs *funcs,
                                        CardState           *state,
                                        DFBAccelerationMask  accel );

bool      xcodeDummyBlit               ( void                 *drv, 
                                        void                 *dev, 
                                        DFBRectangle         *rect, 
                                        int                  dx, 
                                        int                  dy )
;

bool      xcodeDummyFillRectangle      ( void                *drv, 
                                        void                *dev, 
                                        DFBRectangle        *rect );

bool      xcodeDummyStretchBlit        ( void                *drv, 
                                        void                *dev, 
                                        DFBRectangle        *src_rec, 
                                        DFBRectangle        *dst_rec);
                                    
#define G2D_DOWNSCALE_LIMIT 8

#endif

