/*  Copyright (c) 2006-2010 VIXS Systems Inc. All rights reserved
*
*  FILENAME: xcode4_adv7511.h
*
*  DESCRIPTION: ADV7511 DirectFB driver extension for XCode4 
*
*  AUTHOR:
*
*  HISTORY
*
*/

#ifndef __VIXS_ADV7511_MODES_H__
#define __VIXS_ADV7511_MODES_H__

#include "xcode4_osd.h"



/* 720p60 script, it will also work with 720p50 */
const unsigned char porta_720p60[] =
    {
     0x01, 0x00,	/* */
     0x02, 0x18,    
     0x03, 0x00,
     0x15, 0x00,
     0x16, 0x30,
     0x17, 0x01,
     0x18, 0x46,
     0x35, 0x41,	/*R0x35 = 0x41 */
     0x36, 0x49,	/*R0x36 = 0x49 */
     0x37, 0x0A,
     0x38, 0x00,
     0x39, 0x2D,
     0x3A, 0x00,
     0x40, 0x80,
     0x41, 0x10,
     0x48, 0x08,
     0x49, 0xA8,
     0x4C, 0x00,
     0x55, 0x40,
     0x56, 0x08,
     0x96, 0x20,
     0x98, 0x03,
     0x99, 0x02,
     0x9C, 0x30,
     0x9D, 0x61,
     0xA2, 0xA4,
     0xA3, 0xA4,
     0xA5, 0x44,
     0xAB, 0x40,
     0xAF, 0x16,
     0xBA, 0x60,
     0xD1, 0xFF,
     0xD6, 0xC0,  /* Do not power down Tx if HPD is removed */
     0xDE, 0x9C,
     0xE4, 0x60,
     0xFA, 0x7D,
     
     0x00, 0x00
    };

/* 1080p24 Frame packing script */
const unsigned char porta_1080p24fp[] =
    {0x01, 0x00,
     0x02, 0x18,
     0x03, 0x00,
     0x15, 0x00,
     0x16, 0x60,
     0x17, 0x01,
     0x18, 0x46,
     0x35, 0x30,
     0x36, 0xA9,
     0x37, 0x0F,
     0x38, 0x00,
     0x39, 0x89,
     0x3A, 0xD0,
     0x40, 0x80,
     0x41, 0x10,
     0x48, 0x08,
     0x49, 0xA8,
     0x4C, 0x00,
     0x55, 0x40,
     0x56, 0x08,
     0x96, 0x20,
     0x98, 0x03,
     0x99, 0x02,
     0x9C, 0x30,
     0x9D, 0x61,
     0xA2, 0xA4,
     0xA3, 0xA4,
     0xA5, 0x44,
     0xAB, 0x40,
     0xAF, 0x16,
     0xBA, 0x60,
     0xD1, 0xFF,
     0xD6, 0xC0,  /* Do not power down Tx if HPD is removed */
     0xDE, 0x9C,
     0xE4, 0x60,
     0xFA, 0x7D,
     0x00, 0x00
    };

/* 480p60 */
const unsigned char porta_480p60[] =
    {
        0x01, 0x00,
        0x02, 0x18,
        0x03, 0x00,
        0x15, 0x00,
        0x16, 0x60,
        0x17, 0x01,
        0x18, 0x46,
        0x35, 0x1E,
        0x36, 0x64,
        0x37, 0x05,
        0x38, 0xA0,
        0x39, 0x1E,
        0x3A, 0x00,
        0x40, 0x80,
        0x41, 0x10,
        0x48, 0x08,
        0x49, 0xA8,
        0x4C, 0x00,
        0x55, 0x40,
        0x56, 0x08, 
        0x96, 0x20,
        0x98, 0x03,
        0x99, 0x02,
        0x9C, 0x30,
        0x9D, 0x61,
        0xA2, 0xA4,
        0xA3, 0xA4,
        0xA5, 0x44,
        0xAB, 0x40,
        0xAF, 0x16,
        0xBA, 0x60,
        0xD1, 0xFF,
		0xD6, 0xC0,  /* Do not power down Tx if HPD is removed */
        0xDE, 0x9C,
        0xE4, 0x60,
        0xFA, 0x7D,
        0x00, 0x00
    };


/* 720p60 Framepacking */
const unsigned char porta_720p60fp[] =
    {0x01, 0x00,
     0x02, 0x18,
     0x03, 0x00,
     0x15, 0x00,
     0x16, 0x60,
     0x17, 0x61,	/* Do a sync polarity inversion on the HDMI output (0x60) */
     0x18, 0x46,
     0x35, 0x41,
     0x36, 0x49,
     0x37, 0x0A,
     0x38, 0x00,
     0x39, 0x5B,
     0x3A, 0xE0,
     0x40, 0x80,
     0x41, 0x10,
     0x48, 0x08,
     0x49, 0xA8,
     0x4C, 0x00,
     0x55, 0x40,
     0x56, 0x08,
     0x96, 0x20,
     0x98, 0x03,
     0x99, 0x02,
     0x9C, 0x30,
     0x9D, 0x61,
     0xA2, 0xA4,
     0xA3, 0xA4,
     0xA5, 0x44,
     0xAB, 0x40,
     0xAF, 0x16,
     0xBA, 0x60,
     0xD1, 0xFF,
     0xD6, 0xC0,  /* Do not power down Tx if HPD is removed */
     0xDE, 0x9C,
     0xE4, 0x60,
     0xFA, 0x7D,
     0x00, 0x00
    };

/* 1080i60 */
const unsigned char porta_1080i60[] =
    {
		0x01, 0x00,
        0x02, 0x18,
        0x03, 0x00,
        0x15, 0x00,
        0x16, 0x60,
        0x17, 0x01,
        0x18, 0x46,
        0x35, 0x2F,
        0x36, 0xD4,
        0x37, 0x0F,
        0x38, 0x00,
        0x39, 0x21,
        0x3A, 0xC0,
        0x40, 0x80,
        0x41, 0x10,
        0x48, 0x08,
        0x49, 0xA8,
        0x4C, 0x00,
        0x55, 0x40,
        0x56, 0x08,
        0x96, 0x20, 
        0x98, 0x03,
        0x99, 0x02,
        0x9C, 0x30,
        0x9D, 0x61,
        0xA2, 0xA4,
        0xA3, 0xA4,
        0xA5, 0x44,
        0xAB, 0x40,
        0xAF, 0x16,
        0xBA, 0x60,
        0xD1, 0xFF,
		0xD6, 0xC0,  /* Do not power down Tx if HPD is removed */
        0xDE, 0x9C,
        0xE4, 0x60,
        0xFA, 0x7D,
        0x00, 0x00	    
    };

/* 1080i50 */
const unsigned char porta_1080i50[] =
    {
		0x01, 0x00,
        0x02, 0x18,
        0x03, 0x00,
        0x15, 0x00,
        0x16, 0x60,
        0x17, 0x01,
        0x18, 0x46,
        0x35, 0x2F,
        0x36, 0xD4,
        0x37, 0x0F,
        0x38, 0x00,
        0x39, 0x21,
        0x3A, 0xC0,
        0x40, 0x80,
        0x41, 0x10,
        0x48, 0x08,
        0x49, 0xA8,
        0x4C, 0x00,
        0x55, 0x40,
        0x56, 0x08,
        0x96, 0x20, 
        0x98, 0x03,
        0x99, 0x02,
        0x9C, 0x30,
        0x9D, 0x61,
        0xA2, 0xA4,
        0xA3, 0xA4,
        0xA5, 0x44,
        0xAB, 0x40,
        0xAF, 0x16,
        0xBA, 0x60,
        0xD1, 0xFF,
		0xD6, 0xC0,  /* Do not power down Tx if HPD is removed */
        0xDE, 0x9C,
        0xE4, 0x60,
        0xFA, 0x7D,
        0x00, 0x00	    
    };

/* 480i60 */
const unsigned char porta_480i60[] =
    {
        0x01, 0x00,
        0x02, 0x18,
        0x03, 0x00,
        0x15, 0x00,
        0x16, 0x60,
        0x17, 0x01,
        0x18, 0x46,
        0x35, 0x1D,
        0x36, 0x92,
        0x37, 0x05,
        0x38, 0xA0,
        0x39, 0x0F,
        0x3A, 0x00,
        0x40, 0x80,
        0x41, 0x10,
        0x48, 0x08,
        0x49, 0xA8,
        0x4C, 0x00,
        0x55, 0x40,
        0x56, 0x08,
        0x96, 0x20, 
        0x98, 0x03,
        0x99, 0x02,
        0x9C, 0x30,
        0x9D, 0x61,
        0xA2, 0xA4,
        0xA3, 0xA4,
        0xA5, 0x44,
        0xAB, 0x40,
        0xAF, 0x16,
        0xBA, 0x60,
        0xD1, 0xFF,
		0xD6, 0xC0,  /* Do not power down Tx if HPD is removed */
        0xDE, 0x9C,
        0xE4, 0x60,
        0xFA, 0x7D,
        0x00, 0x00
    };

/* 1080p60 */
const unsigned char porta_1080p60[] =
    {
        0x01, 0x00,
        0x02, 0x18,
        0x03, 0x00,
        0x15, 0x00,
        0x16, 0x60,
        0x17, 0x01,
        0x18, 0x46,
        0x35, 0x30,
        0x36, 0xA9,
        0x37, 0x0F,
        0x38, 0x00,
        0x39, 0x43,
        0x3A, 0x80,
        0x40, 0x80,
        0x41, 0x10,
        0x48, 0x08,
        0x49, 0xA8,
        0x4C, 0x00,
        0x55, 0x40,
        0x56, 0x08,
        0x96, 0x20,
        0x98, 0x03,
        0x99, 0x02,
        0x9C, 0x30,
        0x9D, 0x61,
        0xA2, 0xA4,
        0xA3, 0xA4,
        0xA5, 0x44,
        0xAB, 0x40,
        0xAF, 0x16,
        0xBA, 0x60,
        0xD1, 0xFF,
		0xD6, 0xC0,  /* Do not power down Tx if HPD is removed */
        0xDE, 0x9C,
        0xE4, 0x60,
        0xFA, 0x7D,
        0x00, 0x00
    };

/* #ifndef ... */
#endif
