/************************************************** 
*
*  Copyright (c) 2006-2007 VIXS Systems Inc. All rights reserved
*
*  FILENAME: xcode4_video_vid1.c  
*
*  DESCRIPTION: Contains Xcode-IIII DirectFB driver implemntation  
*               
*  AUTHOR:
*
*  HISTORY
*
*
***************************************************/


#include <config.h>

#include <dfb_types.h>

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <math.h>

#include <sys/mman.h>
#include <fcntl.h>
#include <sys/ioctl.h>


#include <directfb.h>

#include <direct/messages.h>
#include <direct/util.h>

#include <core/coredefs.h>
#include <core/coretypes.h>

#include <core/screens.h>
#include <core/state.h>
#include <core/gfxcard.h>
#include <core/layers_internal.h>
#include <core/layers.h>
#include <core/surface.h>
#include <core/palette.h>

#include <display/idirectfbsurface.h>

#include <gfx/convert.h>
#include <gfx/util.h>

#include <misc/conf.h>

#include "viper.h"
#include "xcmmio.h"
#include "xc4fb_if.h"
#include "xcode4_2d.h"
#include "xcode4_osd.h"
#include "xcioctl.h"

extern DFBResult xcode4_flip_interlaced_video(void                  *driver_data,
                                                                                       void                  *layer_data, 
                                                                                       const DFBRegion * region, 
                                                                                       u32 * disp_hd_vid_register_table);


extern DFBResult xcode4_get_fifo_status(void                   *driver_data,
                                 void                   *layer_data,
                                 int                    *fifo_status,
                                 u32 * disp_hd_vid_register_table )
;

extern DFBResult xcode4_clear_frame_consume(void                   *driver_data,
                                     void                   *layer_data,
                                     u32 * disp_hd_vid_register_table )
;

extern DFBResult convert_dfb_format_to_disp_format(const CoreLayerRegionConfig *config, 
                                            int * disp_format);

extern void Calculate_video_sca_inv_ratio(struct display_mode_struct * mode, //output video mode pointer
                                   CoreLayerRegionConfig    * config, //input video 
                                   u32 * video_vsca_inv_ratio,
                                   u32 * video_hsca_inv_ratio,
                                   u32 * vid_vsca_init0,
                                   u32 * vid_vsca_init1,
                                   u32 * vid_vsca_start,
                                   u32 x_round_down);

extern DFBResult Xcode_Set_Video_Plane(CoreLayer                  *layer,
                                      void                       *driver_data,
                                      void                       *layer_data,
                                      CoreLayerRegionConfig      *config,
                                      CoreSurfaceBufferLock      *lock,
                                      CoreSurface                *surface,
                                      CoreLayerRegionConfigFlags  updated,
                                      u32 * disp_hd_vid_register_table);

extern DFBResult Vid_Set_Color_Adjustment( void               *driver_data,
                                           void               *layer_data,
                                           DFBColorAdjustment *adj,
                                           u32  * disp_hd_vid_register_table);

extern int XcodeVidLayerDataSize();

extern DFBResult Xcode_Video_Plane_Update_Region(void                       *driver_data,
								            void                       *layer_data,
									        const DFBRegion       *update,
                                            u32 * disp_hd_vid_register_table);

extern DFBResult Set_Layer_Level( void *driver_data,
                 int level,
                 u32 reg_left_shift,
                 u32 reg_mask);

extern inline int Get_Layer_Level( void *driver_data,
                  u32 reg_right_shift,
                  u32 reg_mask);

extern DFBResult xcode4_get_current_frame_consume(void                   *driver_data,
                                           void                   *layer_data,
                                           int                    *field,
                                           u32 * disp_hd_vid_register_table );


u32 disp_hd_vid1_register_table[SIZE_OF_DISP_VID_REGISTER_TABLE];

/**********************************************************************************************************************/
void Init_Disp_Vid1_Register_Table()
{
    //set register table
    disp_hd_vid1_register_table[DISP_HD_VID_FORMAT_INDEX] = DISP_HD_VID1_FORMAT;
    disp_hd_vid1_register_table[DISP_HD_VID_BUF_PITCH_INDEX] = DISP_HD_VID1_BUF_PITCH;
    disp_hd_vid1_register_table[DISP_HD_VID_BUF_SIZE_INDEX] = DISP_HD_VID1_BUF_SIZE;
    disp_hd_vid1_register_table[DISP_HD_VID_SIZE_INDEX] = DISP_HD_VID1_SIZE;
    disp_hd_vid1_register_table[DISP_HD_VID_SAMPLES_INDEX] = DISP_HD_VID1_SAMPLES;
    disp_hd_vid1_register_table[DISP_HD_VID_SCALED_SIZE_INDEX] = DISP_HD_VID1_SCALED_SIZE;
    disp_hd_vid1_register_table[DISP_HD_COMP_VID_POS_INDEX] = DISP_HD_COMP_VID1_POS;
    disp_hd_vid1_register_table[DISP_HD_VID_VSCA_INV_RATIO_INDEX] = DISP_HD_VID1_VSCA_INV_RATIO;
    disp_hd_vid1_register_table[DISP_HD_VID_HSCA_INV_RATIO_INDEX] = DISP_HD_VID1_HSCA_INV_RATIO;
    disp_hd_vid1_register_table[DISP_HD_VID_VSCA_INIT0_INDEX] = DISP_HD_VID1_VSCA_INIT0;
    disp_hd_vid1_register_table[DISP_HD_VID_VSCA_INIT1_INDEX] = DISP_HD_VID1_VSCA_INIT1;
    disp_hd_vid1_register_table[DISP_HD_VID_VSCA_START_INDEX] = DISP_HD_VID1_VSCA_START;
    disp_hd_vid1_register_table[DISP_HD_VID_VSCALER_Y_BASE_ADDRESS_INDEX] = DISP_HD_VID1_VSCALER_Y_BASE_ADDRESS;
    disp_hd_vid1_register_table[DISP_HD_VID_VSCALER_CBCR_BASE_ADDRESS_INDEX] = DISP_HD_VID1_VSCALER_CBCR_BASE_ADDRESS;
    disp_hd_vid1_register_table[DISP_HD_VID_HSCALER_Y_BASE_ADDRESS_INDEX] = DISP_HD_VID1_HSCALER_Y_BASE_ADDRESS;
    disp_hd_vid1_register_table[DISP_HD_VID_HSCALER_CBCR_BASE_ADDRESS_INDEX] = DISP_HD_VID1_HSCALER_CBCR_BASE_ADDRESS;
    disp_hd_vid1_register_table[DISP_HD_COMP_ALPHA_VID_SHIFT_INDEX] = ALPHA_V1_SHIFT;
    disp_hd_vid1_register_table[DISP_HD_VID_HSBC0_INDEX] = DISP_HD_VID1_HSBC0;
    disp_hd_vid1_register_table[DISP_HD_VID_HSBC1_INDEX] = DISP_HD_VID1_HSBC1;
    disp_hd_vid1_register_table[DISP_HD_VID_HSBC2_INDEX] = DISP_HD_VID1_HSBC2;
    disp_hd_vid1_register_table[DISP_HD_VID_Y_ADR_INDEX] = DISP_HD_VID1_Y_ADR;
    disp_hd_vid1_register_table[DISP_HD_VID_CB_ADR_INDEX] = DISP_HD_VID1_CB_ADR;
    disp_hd_vid1_register_table[DISP_HD_VID_CR_ADR_INDEX] = DISP_HD_VID1_CR_ADR;
    disp_hd_vid1_register_table[ALPHA_VID_MASK_INDEX] = ALPHA_V1_MASK;

    disp_hd_vid1_register_table[DISP_HD_VID_HSCA_INIT_INDEX] = DISP_HD_VID1_HSCA_INIT;
    disp_hd_vid1_register_table[DISP_HD_VID_HSCA_START_INDEX] = DISP_HD_VID1_HSCA_START;
    disp_hd_vid1_register_table[DISP_HD_CMD_FIFO_INDEX] = DISP_HD_VID1_CMD0_FIFO;
    disp_hd_vid1_register_table[DISP_HD_CURR_CMD_INDEX] = DISP_HD_CURR_CMD1;
    disp_hd_vid1_register_table[DISP_HD_VID_FREE_ENTRIES_MASK_INDEX] = VID1_FREE_ENTRIES_MASK;
    disp_hd_vid1_register_table[DISP_HD_VID_FREE_ENTRIES_SHIFT_INDEX] = VID1_FREE_ENTRIES_SHIFT;
    disp_hd_vid1_register_table[DISP_HD_VID_FORMAT_MAX_REQ_LINE_INDEX] = DEFAULT_VID1_MAX_REQ_LINE;
    disp_hd_vid1_register_table[DISP_HD_VID_VERTICAL_SCALER_TAP_INDEX] = VID1_VERTICAL_SCALER_TAPS;
    disp_hd_vid1_register_table[DISP_HD_COMP_LUMA_KEY_INDEX] = DISP_HD_COMP_LUMA_KEY1;
    disp_hd_vid1_register_table[VID_EMPTY_MASK_INDEX] = VID1_EMPTY_MASK;
    disp_hd_vid1_register_table[HD_CC_VID_MODE_SHIFT_INDEX] = VID1_MODE_SHIFT;
    disp_hd_vid1_register_table[HD_CC_VID_MODE_MASK_INDEX] = VID1_MODE_MASK;
    
    /* Y Limit registers for VID1... */
    disp_hd_vid1_register_table[DISP_HD_VID_INPUT_Y_LIMIT_INDEX]        =   DISP_HD_VID1_INPUT_Y_LIMIT;
    disp_hd_vid1_register_table[DISP_HD_VID_INPUT_Y_PLUS_MASK_INDEX]    =   DISP_HD_VID1_INPUT_Y_LIMIT_Y_LIMIT_PLUS_MASK;
    disp_hd_vid1_register_table[DISP_HD_VID_INPUT_Y_MINUS_MASK_INDEX]   =   DISP_HD_VID1_INPUT_Y_LIMIT_Y_LIMIT_MINUS_MASK;
    disp_hd_vid1_register_table[DISP_HD_VID_INPUT_Y_PLUS_SHIFT_INDEX]   =   DISP_HD_VID1_INPUT_Y_LIMIT_Y_LIMIT_PLUS_SHIFT;
    disp_hd_vid1_register_table[DISP_HD_VID_INPUT_Y_MINUS_SHIFT_INDEX]  =   DISP_HD_VID1_INPUT_Y_LIMIT_Y_LIMIT_MINUS_SHIFT;
    
    disp_hd_vid1_register_table[DISP_HD_VID_INPUT_CBCR_LIMIT_INDEX]        =   DISP_HD_VID1_INPUT_CBCR_LIMIT;
    disp_hd_vid1_register_table[DISP_HD_VID_INPUT_CBCR_PLUS_MASK_INDEX]    =   DISP_HD_VID1_INPUT_CBCR_LIMIT_CBCR_LIMIT_PLUS_MASK;
    disp_hd_vid1_register_table[DISP_HD_VID_INPUT_CBCR_MINUS_MASK_INDEX]   =   DISP_HD_VID1_INPUT_CBCR_LIMIT_CBCR_LIMIT_MINUS_MASK;
    disp_hd_vid1_register_table[DISP_HD_VID_INPUT_CBCR_PLUS_SHIFT_INDEX]   =   DISP_HD_VID1_INPUT_CBCR_LIMIT_CBCR_LIMIT_PLUS_SHIFT;
    disp_hd_vid1_register_table[DISP_HD_VID_INPUT_CBCR_MINUS_SHIFT_INDEX]  =   DISP_HD_VID1_INPUT_CBCR_LIMIT_CBCR_LIMIT_MINUS_SHIFT;
    

}

/**********************************************************************************************************************/

static DFBResult
XcodeVid1InitLayer( CoreLayer                *layer,
                    void                       *driver_data,
                    void                       *layer_data,
                    DFBDisplayLayerDescription *description,
                    DFBDisplayLayerConfig      *config,
                    DFBColorAdjustment         *adjustment )
{
     u32     tmp;
     pthread_mutexattr_t mutex_attr;

     pxc_dfb_layer_data m_layer_data = (pxc_dfb_layer_data) layer_data;
     pxc_dfb_driver_data mdrv = (pxc_dfb_driver_data) driver_data;
     D_DEBUG( "xcode DFB driver XcodeVid1InitLayer enter:\n" );


     /* set capabilities and type */
     description->caps = DLCAPS_SURFACE | DLCAPS_ALPHACHANNEL | DLCAPS_OPACITY | 
                         DLCAPS_SCREEN_POSITION | DLCAPS_SCREEN_LOCATION | DLCAPS_LEVELS;

     description->type = DLTF_VIDEO;

     /* set name */
     snprintf( description->name, DFB_DISPLAY_LAYER_DESC_NAME_LENGTH, "ViXS Xcode4 Video Plane 1" );

     /* fill out the default configuration */
     config->flags       = DLCONF_WIDTH       | DLCONF_HEIGHT |
                           DLCONF_PIXELFORMAT | DLCONF_BUFFERMODE | DLCONF_OPTIONS | DLCONF_SURFACE_CAPS ;
     if (dfb_config->preallocate_video1_buffer_number)
     {
         config->width       = DEFAULT_VIDEO_BUFFER_WIDTH;
         config->height      = DEFAULT_VIDEO_BUFFER_HEIGHT * dfb_config->preallocate_video1_buffer_number;
     }
     else
     {
         config->width       = XCODE_DEFAULT_WIDTH;
         config->height      = XCODE_DEFAULT_HEIGHT;
     }

     config->pixelformat = DSPF_I420;
     config->buffermode  = DLBM_FRONTONLY;
     config->surface_caps |= DSCAPS_STATIC_ALLOC ;
     config->options     |= DLOP_OPACITY;


     adjustment->flags   = DCAF_ALL;
     adjustment->brightness = LAYER_DEFAULT_BRIGHT;
     adjustment->contrast = LAYER_DEFAULT_CONTRAST;
     adjustment->saturation = LAYER_DEFAULT_SATURATION;
     adjustment->hue = LAYER_DEFAULT_HUE;
     adjustment->luma_filtertaps    =   10;
     adjustment->chroma_filtertaps  =   10;
     
     /* No sharpness modifications */
     adjustment->sharpness  =   adjustment->hsharpness  =   adjustment->vsharpness  =
     adjustment->combine_sharpness  =   LAYER_DEFAULT_SHARPNESS_VALUE;
     
     /* Softens are kept at 1.0 */
     adjustment->luma_soften    =   adjustment->chroma_soften   =   LAYER_DEFAULT_SOFTEN_VALUE;
     
     /* Gains are kept at 1.0 */
     adjustment->luma_gain  =   adjustment->chroma_gain =   LAYER_DEFAULT_GAIN_VALUE;
     
     m_layer_data->last_frame_counter = 0;
     m_layer_data->total_submitted_frames = 0;
     m_layer_data->total_return_frame_to_free = 0;
     m_layer_data->layer_is_set = 0;
     m_layer_data->status = 0;
     m_layer_data->layer_set_return_fail_counter = 0;
     m_layer_data->last_drop_flag = 0;
     m_layer_data->last_frame_index = -1;

     pthread_mutexattr_init( &mutex_attr );
     pthread_mutexattr_setpshared( &mutex_attr, PTHREAD_PROCESS_SHARED );
     pthread_mutex_init(&m_layer_data->layer_mutex, &mutex_attr);

     Init_Disp_Vid1_Register_Table();
     
     //Color Adjustment part (default adjustment parts)
     m_layer_data->colorParams.premulty =   1.0f;
     m_layer_data->colorParams.premultc =   1.0f;
     
     m_layer_data->colorParams.vysoften  =   1.0f;
     m_layer_data->colorParams.hysoften  =   1.0f;
     m_layer_data->colorParams.vcsoften  =   1.0f;
     m_layer_data->colorParams.hcsoften  =   1.0f;
     
     m_layer_data->colorParams.vysharpen  =   0.0f;
     m_layer_data->colorParams.hysharpen  =   0.0f;
     m_layer_data->colorParams.vcsharpen  =   0.0f;
     m_layer_data->colorParams.hcsharpen  =   0.0f;
     
     m_layer_data->colorParams.ntaps_up_c  =   10;
     m_layer_data->colorParams.ntaps_up_y  =   10;
     
     D_DEBUG( "xcode DFB driver XcodeVid1InitLayer exit:\n" );

     return DFB_OK;
}

/**********************************************************************************************************************/

static DFBResult
XcodeVid1TestRegion( CoreLayer                  *layer,
                     void                       *driver_data,
                     void                       *layer_data,
                     CoreLayerRegionConfig      *config,
                     CoreLayerRegionConfigFlags *failed )
{
     CoreLayerRegionConfigFlags fail = 0;

     D_DEBUG( "xcode DFB driver XcodeVid1TestRegion enter:\n" );

     D_DEBUG ("surface width %d \n", config->width);
     D_DEBUG ("surface height %d \n", config->height);
     D_DEBUG ("destination x %d \n", config->dest.x);
     D_DEBUG ("destination y %d \n", config->dest.y);
     D_DEBUG ("destination weight %d \n", config->dest.w);
     D_DEBUG ("destination height %d \n", config->dest.h);
     D_DEBUG ("surface caps %d \n", config->surface_caps);
     D_DEBUG ("surface options %d \n", config->options);

     if (config->options & ~XCODE4_VID_SUPPORTED_OPTIONS)
          fail |= CLRCF_OPTIONS;

     switch (config->format) {
          case DSPF_I420:
          case DSPF_YV12:
          case DSPF_YV16:  //replaced DSPF_UYVY
          case DSPF_YUY2:  //TODO: not consistent with DirectFB pixel format.
         case DSPF_RGB16:
               break;

          default:
               fail |= CLRCF_FORMAT;
     }

     if (failed)
          *failed = fail;

     if (fail)
     {
          return DFB_UNSUPPORTED;
     }

     D_DEBUG( "xcode DFB driver XcodeVid1TestRegion exit:\n" );

     return DFB_OK;
}

/****************************************************************************************************************************/
void Shared_Vid1_With_Vid0_buffer(pxc_dfb_driver_data mdrv)
{
    u32 tmp;

    tmp = REG_READ(DISP_HD_VID0_Y_ADR);
	REG_WRITE(DISP_HD_VID1_Y_ADR, tmp);

    tmp = REG_READ(DISP_HD_VID0_CB_ADR);
	REG_WRITE(DISP_HD_VID1_CB_ADR, tmp);

    tmp = REG_READ(DISP_HD_VID0_CR_ADR);
	REG_WRITE(DISP_HD_VID1_CR_ADR, tmp);

}

/***************************************************************************************/


static DFBResult
XcodeVid1SetRegion( CoreLayer                  *layer,
                    void                       *driver_data,
                    void                       *layer_data,
                    void                       *region_data,
                    CoreLayerRegionConfig      *config,
                    CoreLayerRegionConfigFlags  updated,
                    CoreSurface                *surface,
                    CorePalette                *palette,
                    CoreSurfaceBufferLock      *lock )
{
    int     ret;
    D_ASSERT( driver_data != NULL );
    D_ASSERT( layer_data != NULL );
    pxc_dfb_driver_data mdrv = (pxc_dfb_driver_data) driver_data;
    pxc_dfb_layer_data m_layer_data = (pxc_dfb_layer_data) layer_data;

    D_DEBUG( "xcode DFB driver XcodeVid1SetRegion enter \n" );
    D_DEBUG ("surface width %d \n", config->width);
    D_DEBUG ("surface height %d \n", config->height);
    D_DEBUG ("destination x %d \n", config->dest.x);
    D_DEBUG ("destination y %d \n", config->dest.y);
    D_DEBUG ("destination weight %d \n", config->dest.w);
    D_DEBUG ("destination height %d \n", config->dest.h);
    D_DEBUG ("layer opacity  %x \n", config->opacity);
    D_DEBUG ("surface caps %d \n", config->surface_caps);
    D_DEBUG ("surface pitch %d \n", lock->pitch);
    D_DEBUG ("surface phys 0x%x \n", lock->phys);
    D_DEBUG( "layer id is %d \n", dfb_layer_id(layer));

    //set hd video1 pipe
    ret =  Xcode_Set_Video_Plane(layer,
                                 driver_data,
                                 layer_data,
                                 config,
                                 lock,
                                 surface,
                                 updated,
                                 disp_hd_vid1_register_table);

    /* Move this outside of the define, or else it will cause side by side modes to not work */
    if (config->surface_caps & DSCAPS_VIXS_MVC_RIGHT)
    {
        Shared_Vid1_With_Vid0_buffer(mdrv);
    }

    D_DEBUG( "xcode DFB driver XcodeVid1SetRegion exit \n" );

    return ret;
}

/****************************************************************************************************************************/

DFBResult XcodeVid1SetColorAdjustment(CoreLayer            *layer,
                                void                 *driver_data,
                                void                 *layer_data,
                                DFBColorAdjustment   *adj)
{
    D_DEBUG( "xcode DFB driver XcodeVid1SetColorAdjustment enter \n" );

    D_DEBUG ("brightness %d \n", adj->brightness);
    D_DEBUG ("contrast  %d \n", adj->contrast );
    D_DEBUG ("hue  %d \n", adj->hue );
    D_DEBUG ("saturation  %d \n", adj->saturation );

    //set hue , bright, contrast, sat
    Vid_Set_Color_Adjustment(driver_data, layer_data, adj, disp_hd_vid1_register_table);

    D_DEBUG( "xcode DFB driver XcodeVid1SetColorAdjustment exit \n" );

    return DFB_OK;
}

/****************************************************************************************************************************/

static DFBResult
XcodeVid1FlipRegion( CoreLayer             *layer,
                 void                  *driver_data,
                 void                  *layer_data,
                 void                  *region_data,
                 CoreSurface           *surface,
                 DFBSurfaceFlipFlags    flags,
                 CoreSurfaceBufferLock *lock )
{
    DFBResult              ret;
    pxc_dfb_driver_data mdrv = (pxc_dfb_driver_data) driver_data;

    D_DEBUG( "xcode DFB driver XcodeVid1FlipRegion enter \n" );

    D_ASSERT( surface != NULL );
    D_ASSERT( lock != NULL );
    D_ASSERT( mdrv != NULL );

    D_DEBUG( "( 0x%08lx [%d] 0x%04x)\n", 
                lock->phys, lock->pitch, flags);

    dfb_surface_flip( surface, false );

    D_DEBUG( "xcode DFB driver XcodeVid1FlipRegion exit \n" );
    return DFB_OK;
}

/****************************************************************************************************************************/

static DFBResult
XcodeVid1UpdateRegion( CoreLayer             *layer,
                   void                  *driver_data,
                   void                  *layer_data,
                   void                  *region_data,
                   CoreSurface           *surface,
                   const DFBRegion       *update,
                   CoreSurfaceBufferLock *lock )
{

     D_DEBUG( "XcodeVid1UpdateRegion enter \n" );
     pxc_dfb_driver_data mdrv = (pxc_dfb_driver_data) driver_data;
     pxc_dfb_layer_data m_layer_data = (pxc_dfb_layer_data) layer_data;

     D_ASSERT( surface != NULL );
     D_ASSERT( lock != NULL );
     D_ASSERT( driver_data != NULL );
     D_ASSERT( layer_data != NULL );
     D_ASSERT( update != NULL );

     DFBResult ret;

     if ((m_layer_data->field_select == INTERLACED_INTERWOVEN_BOTH_FIELD_INTERLEAVE) &&
         (REG_READ(DISP_HD_COMP_SIZE) & DISP_HD_COMP_SIZE_INTERLACED_MASK) &&
         !CURRENT_MODE_IS_3D)
     {
         ret = xcode4_flip_interlaced_video(driver_data, 
                                     layer_data, 
                                     update, 
                                     disp_hd_vid1_register_table);
     }
     else
     {
         ret = Xcode_Video_Plane_Update_Region(driver_data, 
                                     layer_data,
                                     update,
                                     disp_hd_vid1_register_table);
     }

     D_DEBUG( "XcodeVid1UpdateRegion exit \n" );
     return ret;
}

/**********************************************************************************************************************/
static DFBResult
XcodeVid1GetCurrentOutputField( CoreLayer *layer,
                                void      *driver_data,
                                void      *layer_data,
                                int       *field )
{
     DFBResult ret;
     
     D_DEBUG( "XcodeVid1GetCurrentOutputField enter \n" );


     //it's a dummy function
     //upper application would use GetCurrentFrameConsume and GetFifoStatus

     D_DEBUG( "XcodeVid1GetCurrentOutputField exit \n" );
     return DFB_OK;
}

/**********************************************************************************************************************/
static DFBResult
Xcode4Vid1SetInputField( CoreLayer *layer,
                         void      *driver_data,
                         void      *layer_data,
                         void      *region_data,
                         int        field )
{
    DFBResult ret; 

    D_DEBUG( "Xcode4Vid1SetInputField enter \n" );
    D_DEBUG( "field  0x%x \n", field );

    pxc_dfb_layer_data m_layer_data = (pxc_dfb_layer_data) layer_data;

    m_layer_data->ufield_update = field & 0x01;

    D_DEBUG( "Xcode4Vid1SetInputField exit \n" );


    return DFB_OK;
}
/**********************************************************************************************************************/
static DFBResult
XcodeVid1GetLevel( CoreLayer *layer,
             void      *driver_data,
             void      *layer_data,
             int       *level )
{
     
    D_DEBUG( "XcodeVid1GetLevel enter \n" );

	* level = Get_Layer_Level(driver_data, VID1_MUX_SHIFT, VID1_MUX_MASK);

    D_DEBUG( "XcodeVid1GetLevel exit \n" );

    return DFB_OK;
}

/**********************************************************************************************************************/
static DFBResult
XcodeVid1SetLevel( CoreLayer *layer,
             void      *driver_data,
             void      *layer_data,
             int        level )
{
    DFBResult ret;
    pxc_dfb_driver_data mdrv = (pxc_dfb_driver_data) driver_data;
    D_DEBUG ( "XcodeVid1SetLevel enter \n" );
    D_DEBUG ( "level %d \n", level );
    D_DEBUG ( "layer id is %d \n", dfb_layer_id(layer));

    ret = Set_Layer_Level(driver_data, level, VID1_MUX_SHIFT, VID1_MUX_MASK);

    D_DEBUG( "XcodeVid1SetLevel exit \n" );
	
     
    return ret;
}

/**********************************************************************************************************************/
static DFBResult
XcodeVid1GetCurrentFrameConsume( CoreLayer *layer,
             void      *driver_data,
             void      *layer_data,
             int       *frame_consume )
{
    DFBResult ret;
     
    D_DEBUG( "XcodeVid1GetCurrentFrameConsume enter \n" );

    ret =  xcode4_get_current_frame_consume( driver_data,
                                      layer_data,
                                      frame_consume,
                                      disp_hd_vid1_register_table );

    D_DEBUG( "XcodeVid1GetCurrentFrameConsume exit \n" );

    return ret;
}

/**********************************************************************************************************************/
static DFBResult
XcodeVid1ClearCurrentFrameConsume( CoreLayer *layer,
             void      *driver_data,
             void      *layer_data)
{
    DFBResult ret;
     
    D_DEBUG( "XcodeVid1ClearCurrentFrameConsume enter \n" );

    ret =  xcode4_clear_frame_consume( driver_data,
                                      layer_data,
                                      disp_hd_vid1_register_table );

    D_DEBUG( "XcodeVid1ClearCurrentFrameConsume exit \n" );

    return ret;
}

/**********************************************************************************************************************/
static DFBResult
XcodeVid1GetFifoStatus( CoreLayer *layer,
             void      *driver_data,
             void      *layer_data,
             int       *fifo_status )
{
    DFBResult ret;
    D_ASSERT( driver_data != NULL );
    D_ASSERT( layer_data != NULL );
     
    D_DEBUG( "XcodeVid1GetFifoStatus enter \n" );

    ret =  xcode4_get_fifo_status( driver_data,
                                   layer_data,
                                   fifo_status,
                                   disp_hd_vid1_register_table );

    pxc_dfb_driver_data mdrv = (pxc_dfb_driver_data) driver_data;
    pxc_dfb_layer_data m_layer_data = (pxc_dfb_layer_data) layer_data;
    u32 current_fifo_index;
    current_fifo_index = ((REG_READ(DISP_HD_FIFO_STATUS0)) & VID1_CURR_IDX_MASK)
               >> VID1_CURR_IDX_SHIFT;

    *fifo_status = (*fifo_status) | (current_fifo_index << 16);

    D_DEBUG( "XcodeVid1GetFifoStatus exit \n" );

    return ret;
}

/**********************************************************************************************************************/
static DFBResult
XcodeVid1CheckLayerStatus( CoreLayer *layer,
             void      *driver_data,
             void      *layer_data,
             int       status_bit )
{
    DFBResult ret;
    pxc_dfb_driver_data mdrv = (pxc_dfb_driver_data) driver_data;
    pxc_dfb_layer_data m_layer_data = (pxc_dfb_layer_data) layer_data;
     
    D_DEBUG( "XcodeVid1CheckLayerStatus enter \n" );

    if (m_layer_data->status & status_bit)
    {
        ret = DFB_OK;
    }
    else
    {
        ret = DFB_FAILURE;
    }

    if (status_bit == LAYER_CHECK_BIT)
    {
        m_layer_data->status = m_layer_data->status | LAYER_CHECK_BIT;
    }


    D_DEBUG( "XcodeVid1CheckLayerStatus exit \n" );

    return ret;
}


/**********************************************************************************************************************/
static DFBResult
XcodeVid1ReallocateSurface( CoreLayer             *layer,
                          void                  *driver_data,
                          void                  *layer_data,
                          void                  *region_data,
                          CoreLayerRegionConfig *config,
                          CoreSurface           *surface )
{
     DFBResult ret;
     pxc_dfb_layer_data m_layer_data = (pxc_dfb_layer_data) layer_data;

     D_DEBUG( "XcodeVid1ReallocateSurface enter \n" );

     //layer id 
     if ((dfb_config->preallocate_video1_buffer_number) &&
         (surface ))
     {
         CoreSurfaceConfig conf;
         conf.flags  = CSCONF_SIZE;
         conf.size.w = config->width;
         conf.size.h = config->height;
         ret = dfb_surface_arrange_again( surface, CSAID_LAYER0 + dfb_layer_id(layer), CSAF_WRITE|CSAF_READ, &conf );
     }
     else
     {
         ret = DFB_FAILURE;
     }

     D_DEBUG( "XcodeVid1ReallocateSurface exit \n" );

     return ret;
}


/***************************************************************************************/

const DisplayLayerFuncs XcodeVid1LayerFuncs = {
     LayerDataSize:      XcodeVidLayerDataSize,
     InitLayer:          XcodeVid1InitLayer,
     TestRegion:         XcodeVid1TestRegion,
     SetRegion:          XcodeVid1SetRegion,
	 FlipRegion:         XcodeVid1FlipRegion,
	 UpdateRegion:       XcodeVid1UpdateRegion,
	 GetCurrentOutputField: XcodeVid1GetCurrentOutputField,
     GetCurrentFrameConsume: XcodeVid1GetCurrentFrameConsume,
     ClearFrameConsume: XcodeVid1ClearCurrentFrameConsume,
     GetCurrentFifoStatus: XcodeVid1GetFifoStatus,
     SetColorAdjustment: XcodeVid1SetColorAdjustment,
     SetInputField:      Xcode4Vid1SetInputField,
     GetLevel:           XcodeVid1GetLevel,
     SetLevel:           XcodeVid1SetLevel,
     CheckLayerStatus:   XcodeVid1CheckLayerStatus,
     ReallocateSurface:  XcodeVid1ReallocateSurface
};   

