#ifndef __XCODE4_IMAGEPROVIDER_HW_H__
#define __XCODE4_IMAGEPROVIDER_HW_H__


typedef struct {
     IDirectFBDataBuffer *buffer;

     DIRenderCallback     render_callback;
     void                *render_callback_context;

     int                  width;    /*  width of the JPEG image   */
     int                  height;   /*  height of the JPEG image  */
     
     CoreDFB             *core;

     CoreSurface         **pp_surf;
     DFBSurfacePixelFormat comp_colorspace;
} IDirectFBImageProvider_HW_data;


DFBResult
IMG_HW_cache_cleanup(CoreSurface **p_surf);

unsigned int 
get_next_sample_color(unsigned int color, int *channel);

void
generate_sample_image(void *addr, DFBRectangle *rect, unsigned int pitch, DFBSurfacePixelFormat fmt);

DFBResult
HardwareImgDecode(IDirectFBImageProvider_HW_data *data,
                   unsigned int width,
                   unsigned int height,
                   unsigned int size,
                   unsigned int address,
                   DFBSurfacePixelFormat format,
                   DFB_HW_img_type img_type);

DFBResult 
HardwareImg_RenderTo( IDirectFBImageProvider_HW_data *data,
                       IDirectFBSurface       *destination,
                       const DFBRectangle     *dest_rect, 
                       bool                    need_cached,
                       DFB_HW_img_type         img_type);


#endif

