/************************************************** 
*
*  Copyright (c) 2006-2012 VIXS Systems Inc. All rights reserved
*
*  FILENAME: xc4_img_api.h  
*
*  DESCRIPTION:   
*               
*
*  AUTHOR:
*
*  HISTORY
*
*  $Log: not supported by cvs2svn $
*  Revision 1.0  2012/02/28 01:17:47  kchan
*  Initial implementation
*
***************************************************/

#ifndef XCODE4_IMG_API

#define XCODE4_IMG_API 1


#ifndef TIMING
#define TIMING 0
#endif

static inline long myclock()
{
     struct timeval tv;

     gettimeofday (&tv, NULL);

     return (tv.tv_sec * 1000 + tv.tv_usec / 1000);
}


#if TIMING
long _t, _t_temp;

#define TIME_BEGIN()          _t = myclock()
                              
#define TIME(str...)        _t_temp = myclock();\
                         printf(str);          \
                         printf(": %12ldms\n", _t_temp - _t);\
                         _t = _t_temp
#else
#define TIME_BEGIN()    do { } while (0)
#define TIME(str...)       do { } while (0)
#endif


#ifdef __cplusplus
extern "C"
{
#endif

    typedef enum {
         DFB_HW_JPEG = 1,
         DFB_HW_PNG = 2
    } DFB_HW_img_type;

    void *xcode_get_mmr_map_addr();

    void *img_decode_init();
    int img_decoder_open(void *c, unsigned int buf_width, unsigned int buf_height, unsigned int buf_size,
                              unsigned int out_buf_add_phy, DFBSurfacePixelFormat format, DFB_HW_img_type img_type);
    int img_decoder_append_data(void *c, unsigned int size);
    int img_execute_decode(void *c);
    int img_decoder_close(void *c);
    int img_decode_deinit(void *c);
    void *img_get_send_buf_addr(void *c);
    unsigned int img_get_send_buf_size(void *c);


    void img_dump_context_info(void *c);

#ifdef __cplusplus
}
#endif

#endif
