#include <directfb.h>



//when dec_h == (dst_h + 1) && fmt == DSPF_I420, use direct mode. This will not only eliminate the scaling, resulting 
//in less decoding time, but avoid the intermediate entire image buffer, saving memory. 
bool check_direct_mode(DFBSurfacePixelFormat fmt, int dec_w, int dec_h, int dst_w, int dst_h, 
                    int *p_omit_last_line, int *p_omit_last_col)
{
     bool m_direct;

     int m_omit_last_line = 0;
     int m_omit_last_col = 0;

     if (dec_w == dst_w) {
          m_omit_last_col = 0;
          
          if (dec_h == dst_h) {
               m_direct = true;
          } 
          else if(dec_h == (dst_h + 1) && (dec_h & 0x1) && fmt == DSPF_I420) {
               m_direct = true;
               m_omit_last_line = 1;
          } 
          else {
               m_direct = false;
          }
     }
     else if (dec_w == dst_w + 1 && (dec_w & 0x1) && (fmt == DSPF_I420 || fmt == DSPF_YV16)) {          
          if (dec_h == dst_h) {
               m_direct = true;
               m_omit_last_col = 1;
          } 
          else if(dec_h == (dst_h + 1) && (dec_h & 0x1) && fmt == DSPF_I420) {
               m_direct = true;
               m_omit_last_line = 1;
               m_omit_last_col = 1;
          } 
          else {
               m_direct = false;
          }

     }
     else {
          m_direct = false;
     }

     if (p_omit_last_line) {
          *p_omit_last_line = m_omit_last_line;
     }

     if (p_omit_last_col) {
          *p_omit_last_col = m_omit_last_col;
     }

     return m_direct;
}                         

